{% extends 'base.html.twig' %}

{% block title %}Hello TwigController!
{% endblock %}

{% block body %}
{# inclusion #}
{# {% include "shared/_menu.twig" %} #}
{# inclusion avec ignorance d'erreur si page existante #}
{% include "shared/_menu.twig" ignore missing %}
{# inclusion conditionnelle #}
{# {% include condition ? "shared/_menu.twig" : "shared/_menuUser.twig" ignore missing %} #}
{{ render ('menu')}}

	<style>
		.example-wrapper {
			margin: 1em auto;
			max-width: 800px;
			width: 95%;
			font: 18px / 1.5 sans-serif;
		}
		.example-wrapper code {
			background: #F5F5F5;
			padding: 2px 6px;
		}
	</style>

	<div class="example-wrapper">
		<h1>Hello
			{{ controller_name }}! ✅</h1>

		<ul>
			<li>{{tableau[0]}}</li>
			<li>{{tableau['1']}}</li>
			<li>{{tableau["2"]}}</li>
		</ul>

		<ul>
			<li>{{personne.id}}</li>
			<li>{{personne.nom()}}</li>
			<li>{{personne.getPrenom()}}</li>
			{# Concaténation#}
			<li>{{personne.prenom ~ " " ~ personne.nom}}</li>
			{# Débogage #}
			<li>
				{{dump(personne)}}</li>
		</ul>

		{# Déclarer une variable dans un bloc #}
		{% set str='bonjour' %}
		<p>{{ str }}</p>

		{# Donner une portée locale à une variable #}
		{% with %}
		{% set x = 2 %}
		<p>{{ x }}</p>
		{% endwith %}
		{# x n'existe pas en dehors du bloc #}

		{# Ecriture sans set #}
		{% with { x:2 } %}
			<p>
		{{ x }}
		</p>
		{% endwith %}

		{# Par défaut, dans un bloc with on a accès aux variables globales #}
		{% set y = 5 %}
		{% with { x : 2 } %}
			<p>
		{{ x ~ " " ~ y }}
		</p>
		{% endwith %}

		{# Opération arithmétique #}
		{% set x = 2 %}
		{% set y = 5 %}
			<p>
		{{ x + y }}
		</p>

		{# Chercher les occurences dans un tableau #}
			<p>
		{{ 8 in tableau }}
		</p>
		{# affiche 1 #}
			<p>
		{{ 1 not in tableau }}
		</p>
		{# affiche 1 #}
		{# "starts with" (sensible à la casse) #}
			<p>
		{{ personne.prenom starts with 'J' }}
		</p>
		{# affiche 1 #}

		{# "matches" permet de déterminer si une variable respecte un motif donné par une regex (sensible à la casse) #}
			<p>
		{{ personne.prenom matches '/^J.*n$/' }}
		</p>

		{# Structure conditionnelle #}
			{% if tableau[0] > 0 %}
				<p>
				{{ tableau[0] }}
			est positif
		</p>
		{% endif %}

			<p>
			{{ tableau[0] }}
			est
				{% if tableau[0] > 0 %}
				positif
			{% else %}
				négatif
			{% endif %}
		</p>

		<p>
			{{ tableau[0] }}
			est
			{% if tableau[0] > 0 %}
				positif
			{% elseif tableau[0] < 0 %}
				négatif
			{% else %}
				nul
			{% endif %}
		</p>

		{# Tester l'existence d'une variable #}
		<p>
			{% if nom is defined %}
				{{ nom }}
			{% else %}
				doe
			{% endif %}
		</p>

		{# Tester la parité d'une variable #}
		<p>
			{{ tableau[1] }}
			{% if tableau[1] is even %}
				est pair
			{% else %}
				est impair
			{% endif %}
		</p>

		{# Tester si une variable est divisible par 2 #}
		{% if tableau[2] is divisible by(2) %}
			<p>
				{{ tableau[2] }}
				est divisible par 2
			</p>
		{% endif %}

		{# Structure itérative #}
		{# for #}
		<p>
			{% for elt in tableau %}
				<span>{{ elt }}</span>
			{% endfor %}
		</p>

		{# Utilisation de l'opérateur ".." pour définir un intervalle #}
		<p>
			{% for elt in 0..3 %}
				<span>{{ elt }}</span>
			{% endfor %}
		</p>

		{# Même chose avec "range" #}
		<p>
			{% for i in range(0,3) %}
				<span>{{ i }}</span>
			{% endfor %}
		</p>

		{# Modification du pas #}
		<p>
			Utilisation d'un pas dans l'opérateur range
			{% for i in range(low=0, high=7, step=2) %}
				<span>{{ i }}</span>
			{% endfor %}
		</p>

		{# On peut utiliser l'opérateur ".." pour définir un intervalle de caractères #}
		<p>
			Utilisation de l'opérateur ".."
			{% for i in 'a'..'f' %}
				<span>{{ i }}</span>
			{% endfor %}
		</p>

		{# Même chose avec "range" #}
		<p>
			Utilisation de l'opérateur "range"
			{% for i in range('a','f') %}
				<span>{{ i }}</span>
			{% endfor %}
		</p>

		{# for (cle, valeur) #}
		<p>
			{% for cle, valeur in tableau %}
				<span>{{'clé : ' ~ cle ~ ' valeur : ' ~  valeur }}</span>
				/
			{% endfor %}
		</p>

		{# Affichage de la clé avec "loop.index0" (loop = objet, attribut = index0)
																				       index0 prend 0 comme première clé, index prend 1.
																				    #}
		<p>
			{% for valeur in tableau %}
				<span>{{ loop.index0 }}
					:
					{{ valeur }}</span>
				/
			{% endfor %}
		</p>

		{# Filtre #}
		{# "length" affiche la longueur d'une chaine de caractère #}
		<p>{{ personne.prenom | length }}</p>

		{# "trim" supprime les caractères spéciaux indiqués, en début et en fin de chaîne.
																				        Ici trim supprime l'espace en début de châine.
																				    #}
		<p>{{ ' john wick!' | trim | length }}</p>
		{# Ici on supprime le ! mais pas l'espace en début de chaîne #}
		<p>{{ ' john wick !' | trim('!') | length }}</p>
		{# Ici trim supprime l'espace en début de châine mais pas à la fin. #}
		<p>{{ ' john wick ! ' | trim(side = 'left') | length }}</p>
		{# Ici trim supprime l'espace en fin de châine mais pas au début. #}
		<p>{{ ' john wick ! ' | trim('', 'right') | length }}</p>
		{# Capitalize affiche la première lettre en majuscule, upper affiche toutes les lettres en majuscules #}
		<p>{{ personne.prenom | capitalize ~ " " ~ personne.nom | upper }}</p>

		{# Appliquer un filtre à une portion de code #}
		<p>
			{% apply upper %}
			Bonjour
			{{ personne.nom }}
			{% endapply %}
		</p>

		{# Appliquer un filtre sur un tableau #}
		<p>
			{# slice() extrait une portion d'un tableau (index, offset) #}
			{% for elt in tableau | slice(0,2) %}
				<span>{{ elt }}</span>
			{% endfor %}
		</p>

		{# Raccourci de slice() #}
		<p>
			{% for elt in tableau [0:2] %}
				<span>{{ elt }}</span>
			{% endfor %}
		</p>

		{# Au moins un des deux paramètres doit être présent #}
		<p>
			{% for elt in tableau [:1] %}
				<span>{{ elt }}</span>
			{% endfor %}
		</p>
		<p>
			{% for elt in tableau [1:] %}
				<span>{{ elt }}</span>
			{% endfor %}
		</p>

		{# Reduce réalise une opération indiquée au sein d'un tableau #}
		<p>
			{{ tableau | reduce((somme, valeur) => somme + valeur)}}
		</p>
		{# Reduce accepte aussi une valeur initiale #}
		<p>
			{{ tableau | reduce((somme, valeur) => somme + valeur, 5)}}
		</p>

		{# Map applique une fonction sur les éléments du tableau.
																				       Ici, on ajoute 2 à chaque élément puis on les additionne avec reduce.
																				     #}
		<p>
			{{ tableau | map(elt => elt + 2) | reduce((somme, valeur) => somme + valeur)}}
		</p>

		{# Echappement des balises HTML #}
		{# affiche "hello" #}
		<p>
			{{ 'hello <br>' }}
		</p>
		{# Echappement de <br> avec "e" 
																				    Affiche "hello <br>" #}
		<p>
			{{ 'hello <br>' | e }}
		</p>
		{% set chaine = 'bonjour <br>' %}
		{# Pour les variable utilisation de raw #}
		{# Affiche "bonjour <br>" #}
			<p>
		{{ chaine }}
		</p>
		{# Affiche "bonjour" #}
			<p>
		{{ chaine | raw }}
		</p>

		{# Interprétation de différentes balises #}
		{% set test = "<strong>Texte en gras</strong> 
        <script>
            alert('Ceci est un avertissement')
        </script>"
    %}
			<p>
		{{ test | raw }}
		</p>

		{# Même chose avec autoescape #}
			{% autoescape false %}
		{{ test }}
		{% endautoescape %}

		{# Référencement de fichiers - Permet de référencer des fichiers de ressource (CSS, JS...) définit dans le dossier "public" #}
		{# <link href="{{ asset('css/style.css') }}" rel="stylesheet" />
												<script src="{{ asset('js/jquery-1.11.3.js') }}"></script>
												<script src="{{ asset('js/bootstrap.js') }}"></script>
												<script src="{{ asset('js/script.js') }}"></script> #}

		{# Path et url - Elles permettent de référencer une route enregistrée dans notre routeur.
						        path = relatif / url = absolu
						        <a href="{{ path('vehicule_route') }}">Véhicule</a> =  <a href="/vehicule">Accueil</a>
						        <a href="{{ url('vehicule_route') }}">Véhicule</a> = <a href="http://localhost:8000/vehicule">Véhicule</a>
						        #}

		{# Variables globales #}
	{# Requête d'un contrôleur #}
{# {% set id = app.request.get('personne').nom %} #}


</div>
{% endblock %}
